unit Ngraf;

interface
   procedure LINE(xpos1,ypos1,xpos2,ypos2: Double; col: integer);
   procedure COLOR(col: integer);
   procedure CIRCLE(xpos,ypos,r: Double; col: integer; s,e: Double);
   procedure PAINT(xpos,ypos: Double; col, sel: integer);
   procedure OutGDBCS(xpos,ypos: Double; L: string; okisa: integer);
   procedure YA(YAXPOS, YAYPOS, Q:Double);
   procedure BrushCOLOR(col: integer);
   procedure startdemo;   {X^[g̉ʕ\}
   procedure pic;         {lWRCol}}
   procedure coilo(xpos,ypos: Double);{RC}}
   procedure picc;        {lWRCol}}
   procedure grdisplay;   // OtBbN\
   procedure Pgrdisplay;  // v^[OtBbN\
   procedure Demogrdisplay;// fOtBbN\
   procedure CNindisplay; // ̓OtBbN\
implementation

uses Negirisp, Graphics, Forms,SysUtils,printers;

type
  Tzahiyox = array[1..19] of double;
  Tzahiyoy = array[1..19] of double;
  Tindatx  = array[1..13] of double;
  Tindaty  = array[1..13] of double;

var
  zahiyox: Tzahiyox;
  zahiyoy: Tzahiyoy;
  indatx:  Tindatx;
  indaty:  Tindaty;
  zxpos,zypos,xdata1,ydata1,zssq: double;// Wϊ

procedure PYA(YAXPOS,YAYPOS, Q, keisu: Double);
var
  XX, YY: integer;
  YAQ,QYAS,QYAE: Double;
  LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  XX:= round(YAXPOS);
  YY:= round(YAYPOS);
  YAQ:= PI/12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 12 * keisu);
  LENGYAE := round(COS(QYAE) * 12 * keisu);
  OFFYAS := round(SIN(QYAS) * 12 * keisu);
  OFFYAE := round(SIN(QYAE) * 12 * keisu);
  printer.Canvas.MoveTo(XX,YY);
  printer.Canvas.Lineto(XX + LENGYAS,YY + OFFYAS);
  printer.Canvas.MoveTo(XX,YY);
  printer.Canvas.Lineto(XX + LENGYAE,YY + OFFYAE);
end;

procedure PCircleb(xpos, ypos, r: double; s, e: double);
var
  x1,y1,arcpi,ercpi,sum:  double;
  xxi1,yyi1:              integer;
begin
  if e < s then ercpi := e + pi * 2
           else ercpi := e;
  if r < 1 then r := 1;
  x1 := cos(s) * r + xpos;
  y1 := ypos - sin(s) * r;
  xxi1 := round(x1);
  yyi1 := round(y1);
  printer.Canvas.MoveTo(xxi1, yyi1);
  sum := 1;
  arcpi := s + sum/ r/ 8;
  while ercpi > arcpi do
    begin
      if arcpi <= pi * 2 then
        begin
          x1 := cos(arcpi) * r + xpos;
          y1 := ypos - sin(arcpi) * r;
        end
        else
        begin
          x1 := cos(arcpi - pi * 2) * r + xpos;
          y1 := ypos - sin(arcpi - pi * 2) * r;
        end;
      if (xxi1 <> round(x1)) or (yyi1 <> round(y1)) then
        begin
          xxi1 := round(x1);
          yyi1 := round(y1);
          printer.Canvas.Lineto(xxi1, yyi1);
        end;
      sum := sum + 1;
      arcpi := s + sum/ r/ 8;
    end;
  if ercpi <= pi * 2 then
    begin
      x1 := cos(ercpi) * r + xpos;
      y1 := ypos - sin(ercpi) * r;
    end
    else
    begin
      x1 := cos(ercpi - pi * 2) * r + xpos;
      y1 := ypos - sin(ercpi - pi * 2) * r;
    end;
  if (xxi1 <> round(x1)) or (yyi1 <> round(y1)) then
    begin
      xxi1 := round(x1);
      yyi1 := round(y1);
      printer.Canvas.Lineto(xxi1, yyi1);
    end;
end;

procedure BrushCOLOR(col: integer);
begin
  with Form1.Image1.Canvas.Brush do begin
    case col of
     	0: Color := clBlack;
     	1: Color := clNavy;
     	2: Color := clGreen;
     	3: Color := clTeal;
     	4: Color := clMaroon;
     	5: Color := clPurple;
     	6: Color := clOlive;
     	7: Color := clSilver;
     	8: Color := clGray;
     	9: Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
    end;
  end;
end;

procedure COLOR(col: integer);
begin
  with Form1.Image1.Canvas.Pen do begin
    case col of
     	0: Color := clBlack;
     	1: Color := clNavy;
     	2: Color := clGreen;
     	3: Color := clTeal;
     	4: Color := clMaroon;
     	5: Color := clPurple;
     	6: Color := clOlive;
     	7: Color := clSilver;
     	8: Color := clGray;
     	9: Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
    end;
  end;
  with Form1.Image1.Canvas.Font do begin
    case col of
     	0: Color := clBlack;
     	1: Color := clNavy;
     	2: Color := clGreen;
     	3: Color := clTeal;
     	4: Color := clMaroon;
     	5: Color := clPurple;
     	6: Color := clOlive;
     	7: Color := clSilver;
     	8: Color := clGray;
     	9: Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
    end;
  end;
end;

procedure LINE(xpos1,ypos1,xpos2,ypos2: Double; col: integer);
var
  X1,Y1,X2,Y2: integer;
begin
  X1 := round(xpos1);
  Y1 := round(ypos1);
  X2 := round(xpos2);
  Y2 := round(ypos2);
  COLOR(col);
  Form1.Image1.Canvas.MoveTo(X1,Y1);
  Form1.Image1.Canvas.Lineto(X2,Y2);
end;

procedure CIRCLE(xpos,ypos,r: Double; col: integer; s,e: Double);
var
  XT,YT,XB,YB,SX,SY,EX,EY  : integer;
  SX1,SY1,EX1,EY1          : integer;
  rbak: Double;
begin
  rbak := r;
  XT := round(xpos - r);
  YT := round(ypos + r);
  XB := round(xpos + r);
  YB := round(ypos - r);
  SX1 := round(xpos + cos(s) * r);
  SY1 := round(ypos - sin(s) * r);
  EX1 := round(xpos + cos(e) * r);
  EY1 := round(ypos - sin(e) * r);
  if r < 10 then r := r * 10;
  SX := round(xpos + cos(s) * r);
  SY := round(ypos - sin(s) * r);
  EX := round(xpos + cos(e) * r);
  EY := round(ypos - sin(e) * r);
  COLOR(col);
  Form1.Image1.Canvas.Arc(XT, YT, XB, YB, SX, SY, EX, EY);
  if rbak <= 1 then
    begin
      Form1.Image1.Canvas.MoveTo(SX1,SY1);
      Form1.Image1.Canvas.Lineto(EX1,EY1);
  	end;
end;

procedure FILL(XX,YY,sel: integer);
begin
  with Form1.Image1.Canvas do begin
    case sel of
      0: FloodFill(XX,YY, clBlack, fsBorder);
      1: FloodFill(XX,YY, clNavy, fsBorder);
      2: FloodFill(XX,YY, clGreen, fsBorder);
      3: FloodFill(XX,YY, clTeal, fsBorder);
      4: FloodFill(XX,YY, clMaroon, fsBorder);
      5: FloodFill(XX,YY, clPurple, fsBorder);
      6: FloodFill(XX,YY, clOlive, fsBorder);
      7: FloodFill(XX,YY, clSilver, fsBorder);
      8: FloodFill(XX,YY, clGray, fsBorder);
      9: FloodFill(XX,YY, clBlue, fsBorder);
      10:FloodFill(XX,YY, clLime, fsBorder);
      11:FloodFill(XX,YY, clAqua, fsBorder);
      12:FloodFill(XX,YY, clRed, fsBorder);
      13:FloodFill(XX,YY, clFuchsia, fsBorder);
      14:FloodFill(XX,YY, clYellow, fsBorder);
      15:FloodFill(XX,YY, clWhite, fsBorder);
    end;
  end;
end;


procedure PAINT(xpos,ypos: Double; col, sel: integer);
var
   XX, YY: integer;
begin
  XX:= round(xpos);
  YY:= round(ypos);
  {Form1.Image1.Canvas.Brush.Style := bsSolid;}
  {Form1.Image1.Canvas.Brush.Style := bsBDiagonal;}
  BrushCOLOR(col);
  Fill(XX, YY, sel);
end;

procedure OutGDBCS(xpos,ypos: Double; L: string; okisa: integer);
var
  XX, YY: integer;
begin
  okisa := okisa + 3;
  Form1.Image1.Canvas.Font.Height:= okisa;
  XX:= round(xpos);
  YY:= round(ypos);
  Form1.Image1.Canvas.Brush.Style := bsClear;
  Form1.Image1.Canvas.Textout(XX,YY,L);
end;

procedure YA(YAXPOS,YAYPOS,Q: Double);
var
  XX, YY: integer;
  YAQ,QYAS,QYAE: Double;
  LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  XX:= round(YAXPOS);
  YY:= round(YAYPOS);
  YAQ:= PI / 12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 12);
  LENGYAE := round(COS(QYAE) * 12);
  OFFYAS := round(SIN(QYAS) * 12);
  OFFYAE := round(SIN(QYAE) * 12);
  Form1.Image1.Canvas.MoveTo(XX,YY);
  Form1.Image1.Canvas.Lineto(XX + LENGYAS,YY + OFFYAS);
  Form1.Image1.Canvas.MoveTo(XX,YY);
  Form1.Image1.Canvas.Lineto(XX + LENGYAE,YY + OFFYAE);
end;

procedure radconv(xpos,ypos,xdot,ydot,ssq: double);//Wϊ
var
  LLD,Qad: double;
begin
  if abs(xdot - xpos) > 0.0000001 then  //I[o[t[h~
    begin
      Qad := arctan((ypos - ydot)/(xdot - xpos));//px
    end
    else
    begin
      if  ypos < ydot then Qad := pi / 2 + pi
                      else Qad := pi / 2;
    end;
  if (xdot - xpos < 0) then Qad := Qad + pi;
  LLD := sqrt((ypos - ydot)*(ypos - ydot)+ (xdot - xpos)*(xdot - xpos));
  zssq := Qad + ssq;
  If zssq > 2 * pi then zssq := zssq - 2 * pi;
  If zssq < 0 then zssq := zssq + 2 * pi;
  zxpos := xpos + cos(zssq) * LLD;
  zypos := ypos - sin(zssq) * LLD;
end;

procedure Circleb(xpos, ypos, r: double; s, e: double);
var
  x1,y1,arcpi,ercpi,sum:              double;
  xxi1,yyi1:      integer;
begin
  if e < s then ercpi := e + pi * 2
           else ercpi := e;
  if r < 1 then r := 1;
  x1 := cos(s) * r + xpos;
  y1 := ypos - sin(s) * r;
  xxi1 := round(x1);
  yyi1 := round(y1);
  Form1.Image1.Canvas.MoveTo(xxi1, yyi1);
  sum := 1;
  arcpi := s + sum/ r/ 8;
  while ercpi > arcpi do
    begin
      if arcpi <= pi * 2 then
        begin
          x1 := cos(arcpi) * r + xpos;
          y1 := ypos - sin(arcpi) * r;
        end
        else
        begin
          x1 := cos(arcpi - pi * 2) * r + xpos;
          y1 := ypos - sin(arcpi - pi * 2) * r;
        end;
      if (xxi1 <> round(x1)) or (yyi1 <> round(y1)) then
        begin
          xxi1 := round(x1);
          yyi1 := round(y1);
          Form1.Image1.Canvas.Lineto(xxi1, yyi1);
        end;
      sum := sum + 1;
      arcpi := s + sum/ r/ 8;
    end;
  if ercpi <= pi * 2 then
    begin
      x1 := cos(ercpi) * r + xpos;
      y1 := ypos - sin(ercpi) * r;
    end
    else
    begin
      x1 := cos(ercpi - pi * 2) * r + xpos;
      y1 := ypos - sin(ercpi - pi * 2) * r;
    end;
  if (xxi1 <> round(x1)) or (yyi1 <> round(y1)) then
    begin
      xxi1 := round(x1);
      yyi1 := round(y1);
      Form1.Image1.Canvas.Lineto(xxi1, yyi1);
    end;
end;

procedure CNindisplay;// ̓OtBbN\
var
  qtan,setq,RRL: double;
  RLQ2E,RLQ2S: double;
  qtane: double;
  SLL:string;
  tlng: integer;
  RL1g,RL2g,Ad1g,dg,RRLg: double;
  Scl: double;
  Ad1add,Ad1sub,NGQg: double;
  RLC1,RLC2,AdC,DC: double;
begin
     NGQ2 := pi / 5 * 4 - 0.1;
     RLC1 := 40;    // r̒@P
     RLC2 := 40;    // r̒@Q
     AdC := 15;     // a
       dC := 2;     // a
     ppQ1:= NGQ2;   // ׏dpxWAP
     NGQg:= Pi / 2; // lWpWAP

  CLEAR(0);
// ׏dpx
  Form1.Image1.Canvas.pen.Style := psSolid;
  Form1.Image1.Canvas.pen.Width := 1;
  Form1.Image1.Canvas.font.Height := 14;
  Form1.Image1.Canvas.font.color := clFuchsia;
  SLL := floatTostrF(ppQ1/pi*180,ffGeneral,5,5);
  tlng:= Form1.Image1.Canvas.textwidth(SLL);

  if RLC1 < RLC2 then RRL := RLC2 else RRL := RLC1;
  Scl := (300 - tlng)/(RRL + RRL/2)/2;
  RL1g := RLC1 * Scl;            // r̒@P
  RL2g := RLC2 * Scl;            // r̒@Q
  Ad1g := AdC * Scl;             // a
  dg := dC * Scl;                // a
  RRLg := RRL * Scl;

  Ad1add := Ad1g + dg;
  Ad1sub := Ad1g - dg;

  setq := (2 * pi - ppQ1 - 0.3) / 2;  // r̍}px

  xdata1 := Form1.ClientWidth - (200 - tlng)/2;// SWw

  ydata1 := 200;                // SWx
  qtan := arctan(Ad1add/2/sqrt(RL2g * RL2g - Ad1add/2 * Ad1add/2));// RL2g̊px
  indatx[1] := xdata1 + RL2g;   // qkQ̂wW
  indaty[1] := ydata1;          // qkQ̂xW
  radconv(xdata1, ydata1,indatx[1], indaty[1],-setq);// Wϊ
  zahiyox[1] := zxpos;          // qkQ̉׏dwW
  zahiyoy[1] := zypos;          // qkQ̉׏dxW
  indatx[2] := Ad1add/2 * sin(qtan) + xdata1;// qkQ̊O~wW
  indaty[2] := Ad1add/2 * cos(qtan) + ydata1;// qkQ̊O~xW
  radconv(xdata1, ydata1,indatx[2], indaty[2],-setq);//Wϊ
  zahiyox[2] := zxpos;          // qkQ̉׏dO~wW
  zahiyoy[2] := zypos;          // qkQ̉׏dO~xW
  RLQ2E := zssq;                // qkQ̉׏dO~ړ_p
  RLQ2S := arctan(sqrt(Ad1add/2 * Ad1add/2  - Ad1sub/2 * Ad1sub/2)/(Ad1sub/2));
  RLQ2S := RLQ2S + zssq;        // qkQ̉׏dO~_p
  indatx[3] := indatx[2] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}O~[wW
  indaty[3] := indaty[2] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}O~[xW
  radconv(xdata1, ydata1,indatx[3], indaty[3],-setq);// Wϊ
  zahiyox[3] := zxpos;          // qkQ̍}׏dO~[wW
  zahiyoy[3] := zypos;          // qkQ̍}׏dO~[xW
  indatx[4] := xdata1 + sin(qtan) * Ad1sub/ 2;// qkQ̓~wW
  indaty[4] := ydata1 + cos(qtan) * Ad1sub/ 2;// qkQ̓~xW
  radconv(xdata1, ydata1,indatx[4], indaty[4],-setq);// Wϊ
  zahiyox[4] := zxpos;          // qkQ̉׏d~wW
  zahiyoy[4] := zypos;          // qkQ̉׏d~xW
  indatx[5] := indatx[4] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}~[wW
  indaty[5] := indaty[4] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}~[xW
  radconv(xdata1, ydata1,indatx[5], indaty[5],-setq);// Wϊ
  zahiyox[5] := zxpos;          // qkQ̍}׏d~[wW
  zahiyoy[5] := zypos;          // qkQ̍}׏d~[xW
  indatx[6] := xdata1 + (RRLg + RRLg / 2);// qkQ̕⏕[wW
  indaty[6] := ydata1;          // qkQ̕⏕[xW
  radconv(xdata1, ydata1,indatx[6], indaty[6],-setq);// Wϊ
  zahiyox[6] := zxpos;          // qkQ̉׏d⏕[wW
  zahiyoy[6] := zypos;          // qkQ̉׏d⏕[xW

  qtan := arctan(Ad1add/2/sqrt(RL1g * RL1g - Ad1add/2 * Ad1add/2));// RL1g̊px
  indatx[7] := xdata1 + RL1g;   // qkP̂wW
  indaty[7] := ydata1;          // qkP̂xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq);// Wϊ
  zahiyox[7] := zxpos;          // qkP̉׏dwW
  zahiyoy[7] := zypos;          // qkP̉׏dwW
  indatx[8] := xdata1 + Ad1add/2 * sin(qtan);// qkP̊O~wW
  indaty[8] := ydata1 - Ad1add/2 * cos(qtan);// qkP̊O~wW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq);// Wϊ
  zahiyox[8] := zxpos;          // qkP̉׏dO~wW
  zahiyoy[8] := zypos;          // qkP̉׏dO~xW
  indatx[9] := indatx[8] + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}O~[wW
  indaty[9] := indaty[8] + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}O~[xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq);// Wϊ
  zahiyox[9] := zxpos;          // qkP̍}׏dO~[wW
  zahiyoy[9] := zypos;          // qkP̍}׏dO~[xW
  qtane := arctan(sqrt(Ad1add/2 * Ad1add/2 - Ad1sub/2 * Ad1sub/2)/(Ad1sub /2));//qkP̍}O~_px␳
  indatx[10] := xdata1 + sin(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_wW
  indaty[10] := ydata1 - cos(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq);//Wϊ
  zahiyox[10] := zxpos;         // qkP̍}׏dO~_wW
  zahiyoy[10] := zypos;         // qkP̍}׏dO~_xW
  indatx[11] := xdata1 + sin(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}~[wW
  indaty[11] := ydata1 - cos(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq);//Wϊ
  zahiyox[11] := zxpos;         // qkP̍}׏d~[wW
  zahiyoy[11] := zypos;         // qkP̍}׏d~[xW
  indatx[12] := xdata1 + RRLg + RRLg / 2;// qkP̐@⏕[wW
  indaty[12] := ydata1;         // qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq);// Wϊ
  zahiyox[12] := zxpos;         // qkP̉׏d@⏕[wW
  zahiyoy[12] := zypos;         // qkP̉׏d@⏕[xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq + NGQg);// Wϊ
  zahiyox[13] := zxpos;         // qkP̏pxwW
  zahiyoy[13] := zypos;         // qkP̏pxxW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq + NGQg);// Wϊ
  zahiyox[14] := zxpos;         // qkP̏O~wW
  zahiyoy[14] := zypos;         // qkP̏O~xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq + NGQg);// Wϊ
  zahiyox[15] := zxpos;         // qkP̏O~[wW
  zahiyoy[15] := zypos;         // qkP̏O~[xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq + NGQg);// Wϊ
  zahiyox[16] := zxpos;         // qkP̍}O~_wW
  zahiyoy[16] := zypos;         // qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq + NGQg);// Wϊ
  zahiyox[17] := zxpos;         // qkP̍}~[wW
  zahiyoy[17] := zypos;         // qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq + NGQg);// Wϊ
  zahiyox[18] := zxpos;         // qkP̐@⏕[wW
  zahiyoy[18] := zypos;         // qkP̐@⏕[xW

  indatx[13] := xdata1 + RRLg+5;// qkP̐@⏕[wW
  indaty[13] := ydata1;         // qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[13], indaty[13], setq + NGQg);// Wϊ
  zahiyox[19] := zxpos;         // qkP̐@⏕[wW
  zahiyoy[19] := zypos;         // qkP̐@⏕[xW

  with Form1.Image1.Canvas do
    begin
      pen.width := 1;
      pen.Color := Clblack;
// RL2g }
      moveTo(round(zahiyox[1]),round(zahiyoy[1]));
      lineTo(round(zahiyox[2]),round(zahiyoy[2]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
      moveTo(round(zahiyox[4]),round(zahiyoy[4]));
      lineTo(round(zahiyox[5]),round(zahiyoy[5]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
// px⏕@qkQ
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[6]),round(zahiyoy[6]));

// RLP }  ׏dpʒu
      pen.Color := Clgreen;
      moveTo(round(zahiyox[7]),round(zahiyoy[7]));
      lineTo(round(zahiyox[8]),round(zahiyoy[8]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));
      moveTo(round(zahiyox[10]),round(zahiyoy[10]));
      lineTo(round(zahiyox[11]),round(zahiyoy[11]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));

// RL
      pen.Color := clLime;
      moveTo(round(xdata1 - Ad1g / 2 - 2),round(Ydata1 - 40));
      lineTo(round(xdata1 - 110),round(ydata1 - 120));
      lineTo(round(xdata1 - 150),round(ydata1 - 120));
      moveTo(round(xdata1 - Ad1g / 2 - 2),round(Ydata1 + 40));
      lineTo(round(xdata1 - 110),round(ydata1 + 120));
      lineTo(round(xdata1 - 150),round(ydata1 + 120));
      Font.Height := 14;
      Font.color := clBlack;
      Textout(round(xdata1 - 150),round(ydata1 - 136),'qkP');
      Textout(round(xdata1 - 150),round(ydata1 + 104),'qkQ');

// px⏕ qkP
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[12]),round(zahiyoy[12]));

// aAOa
      pen.Color := Clblack;
    end;
  circleb(xdata1, ydata1, Ad1add/2, RLQ2S, RLQ2E);
  circleb(xdata1, ydata1, Ad1sub/2, 0, pi * 2);

// px@
  Form1.Image1.Canvas.pen.Color := Clblue;
  YA(xdata1+(RRLg + RRLg/2 - 5)*cos(setq),ydata1+(RRLg + RRLg/2 - 5)*sin(setq),setq+pi/2);
  YA(xdata1+(RRLg + RRLg/2 - 5)*cos(2*pi-setq),ydata1+(RRLg + RRLg/2 - 5)*sin(2*pi-setq),-setq-pi/2);
  circleb(xdata1, ydata1, RRLg + RRLg/2 - 5, setq, 2 * pi - setq);
// ׏dpx
  SLL := 'w';
  Form1.Image1.Canvas.font.Height := 14;
  Form1.Image1.Canvas.font.color := clFuchsia;
  tlng:= Form1.Image1.Canvas.textwidth(SLL);
  Form1.Image1.Canvas.Textout(round(xdata1-tlng-RRLg-RRLg/2),round(ydata1),SLL);
end;

procedure Demogrdisplay;//OtBbN\
var
  qtan,setq,RRL: double;
  RLQ2E,RLQ2S: double;
  qtane: double;
  SLL:string;
  tlng,Slng: integer;
  RL1g,RL2g,Ad1g,dg,RRLg: double;
  Scl: double;
  Ad1add,Ad1sub,NGQg: double;
begin
     NGQ2 := pi / 5 * 3;
     RL1 := 30;     // r̒@P
     RL2 := 40;     // r̒@Q
     Ad := 15;      // a
       d := 1.5;    // a
     ppQ1:= NGQ2;   // ׏dpxWAP
     NGQg:= Pi / 2; // lWpWAP

// CLEAR(0);
// ׏dpx
  Form1.Image1.Canvas.pen.Style := psSolid;
  Form1.Image1.Canvas.pen.Width := 1;
  Form1.Image1.Canvas.font.Height := 14;
  Form1.Image1.Canvas.font.color := clFuchsia;
  SLL := floatTostrF(ppQ1/pi*180,ffGeneral,5,5);
  SLL := SLL + '';
  tlng:= Form1.Image1.Canvas.textwidth(SLL);

  if RL1 < RL2 then RRL := RL2 else RRL := RL1;
  Scl := (300 - tlng)/(RRL + RRL/2)/2;
  RL1g := RL1 * Scl;            // r̒@P
  RL2g := RL2 * Scl;            // r̒@Q
  Ad1g := Ad * Scl;             // a
  dg := d * Scl;                // a
  RRLg := RRL * Scl;

  Ad1add := Ad1g + dg;
  Ad1sub := Ad1g - dg;

  setq := (2 * pi - ppQ1) / 2;  // r̍}px

  xdata1 := Form1.ClientWidth - (200 - tlng)/2;// SWw

  ydata1 := 200;                // SWx
  qtan := arctan(Ad1add/2/sqrt(RL2g * RL2g - Ad1add/2 * Ad1add/2));// RL2g̊px
  indatx[1] := xdata1 + RL2g;   // qkQ̂wW
  indaty[1] := ydata1;          // qkQ̂xW
  radconv(xdata1, ydata1,indatx[1], indaty[1],-setq);// Wϊ
  zahiyox[1] := zxpos;          // qkQ̉׏dwW
  zahiyoy[1] := zypos;          // qkQ̉׏dxW
  indatx[2] := Ad1add/2 * sin(qtan) + xdata1;// qkQ̊O~wW
  indaty[2] := Ad1add/2 * cos(qtan) + ydata1;// qkQ̊O~xW
  radconv(xdata1, ydata1,indatx[2], indaty[2],-setq);// Wϊ
  zahiyox[2] := zxpos;          // qkQ̉׏dO~wW
  zahiyoy[2] := zypos;          // qkQ̉׏dO~xW
  RLQ2E := zssq;                // qkQ̉׏dO~ړ_p
  RLQ2S := arctan(sqrt(Ad1add/2 * Ad1add/2  - Ad1sub/2 * Ad1sub/2)/(Ad1sub/2));
  RLQ2S := RLQ2S + zssq;        // qkQ̉׏dO~_p
  indatx[3] := indatx[2] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}O~[wW
  indaty[3] := indaty[2] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}O~[xW
  radconv(xdata1, ydata1,indatx[3], indaty[3],-setq);// Wϊ
  zahiyox[3] := zxpos;          // qkQ̍}׏dO~[wW
  zahiyoy[3] := zypos;          // qkQ̍}׏dO~[xW
  indatx[4] := xdata1 + sin(qtan) * Ad1sub/ 2;// qkQ̓~wW
  indaty[4] := ydata1 + cos(qtan) * Ad1sub/ 2;// qkQ̓~xW
  radconv(xdata1, ydata1,indatx[4], indaty[4],-setq);// Wϊ
  zahiyox[4] := zxpos;          // qkQ̉׏d~wW
  zahiyoy[4] := zypos;          // qkQ̉׏d~xW
  indatx[5] := indatx[4] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}~[wW
  indaty[5] := indaty[4] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}~[xW
  radconv(xdata1, ydata1,indatx[5], indaty[5],-setq);// Wϊ
  zahiyox[5] := zxpos;          // qkQ̍}׏d~[wW
  zahiyoy[5] := zypos;          // qkQ̍}׏d~[xW
  indatx[6] := xdata1 + (RRLg + RRLg / 2);// qkQ̕⏕[wW
  indaty[6] := ydata1;          // qkQ̕⏕[xW
  radconv(xdata1, ydata1,indatx[6], indaty[6],-setq);// Wϊ
  zahiyox[6] := zxpos;          // qkQ̉׏d⏕[wW
  zahiyoy[6] := zypos;          // qkQ̉׏d⏕[xW

  qtan := arctan(Ad1add/2/sqrt(RL1g * RL1g - Ad1add/2 * Ad1add/2));//RL1g̊px
  indatx[7] := xdata1 + RL1g;   // qkP̂wW
  indaty[7] := ydata1;          // qkP̂xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq);// Wϊ
  zahiyox[7] := zxpos;          // qkP̉׏dwW
  zahiyoy[7] := zypos;          // qkP̉׏dwW
  indatx[8] := xdata1 + Ad1add/2 * sin(qtan);// qkP̊O~wW
  indaty[8] := ydata1 - Ad1add/2 * cos(qtan);// qkP̊O~wW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq);// Wϊ
  zahiyox[8] := zxpos;          // qkP̉׏dO~wW
  zahiyoy[8] := zypos;          // qkP̉׏dO~xW
  indatx[9] := indatx[8] + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}O~[wW
  indaty[9] := indaty[8] + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}O~[xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq);// Wϊ
  zahiyox[9] := zxpos;          // qkP̍}׏dO~[wW
  zahiyoy[9] := zypos;          // qkP̍}׏dO~[xW
  qtane := arctan(sqrt(Ad1add/2 * Ad1add/2 - Ad1sub/2 * Ad1sub/2)/(Ad1sub /2));// qkP̍}O~_px␳
  indatx[10] := xdata1 + sin(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_wW
  indaty[10] := ydata1 - cos(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq);// Wϊ
  zahiyox[10] := zxpos;         // qkP̍}׏dO~_wW
  zahiyoy[10] := zypos;         // qkP̍}׏dO~_xW
  indatx[11] := xdata1 + sin(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}~[wW
  indaty[11] := ydata1 - cos(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq);// Wϊ
  zahiyox[11] := zxpos;         // qkP̍}׏d~[wW
  zahiyoy[11] := zypos;         // qkP̍}׏d~[xW
  indatx[12] := xdata1 + RRLg + RRLg / 2;// qkP̐@⏕[wW
  indaty[12] := ydata1;         // qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq);// Wϊ
  zahiyox[12] := zxpos;         // qkP̉׏d@⏕[wW
  zahiyoy[12] := zypos;         // qkP̉׏d@⏕[xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq + NGQg);// Wϊ
  zahiyox[13] := zxpos;         // qkP̏pxwW
  zahiyoy[13] := zypos;         // qkP̏pxxW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq + NGQg);// Wϊ
  zahiyox[14] := zxpos;         // qkP̏O~wW
  zahiyoy[14] := zypos;         // qkP̏O~xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq + NGQg);// Wϊ
  zahiyox[15] := zxpos;         // qkP̏O~[wW
  zahiyoy[15] := zypos;         // qkP̏O~[xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq + NGQg);// Wϊ
  zahiyox[16] := zxpos;         // qkP̍}O~_wW
  zahiyoy[16] := zypos;         // qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq + NGQg);// Wϊ
  zahiyox[17] := zxpos;         // qkP̍}~[wW
  zahiyoy[17] := zypos;         // qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq + NGQg);// Wϊ
  zahiyox[18] := zxpos;         // qkP̐@⏕[wW
  zahiyoy[18] := zypos;         // qkP̐@⏕[xW

  indatx[13] := xdata1 + RRLg+5;// qkP̐@⏕[wW
  indaty[13] := ydata1;         // qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[13], indaty[13], setq + NGQg);// Wϊ
  zahiyox[19] := zxpos;         // qkP̐@⏕[wW
  zahiyoy[19] := zypos;         // qkP̐@⏕[xW

  with Form1.Image1.Canvas do
    begin
      pen.width := 1;
      pen.Color := Clblack;
// RL2g }
      moveTo(round(zahiyox[1]),round(zahiyoy[1]));
      lineTo(round(zahiyox[2]),round(zahiyoy[2]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
      moveTo(round(zahiyox[4]),round(zahiyoy[4]));
      lineTo(round(zahiyox[5]),round(zahiyoy[5]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
// px⏕@qkQ
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[6]),round(zahiyoy[6]));

// RLP }  ׏dpʒu
      pen.Color := Clred;
      moveTo(round(zahiyox[7]),round(zahiyoy[7]));
      lineTo(round(zahiyox[8]),round(zahiyoy[8]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));
      moveTo(round(zahiyox[10]),round(zahiyoy[10]));
      lineTo(round(zahiyox[11]),round(zahiyoy[11]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));

// RLP }  pʒu
      pen.Color := clLime;
      moveTo(round(zahiyox[13]),round(zahiyoy[13]));
      lineTo(round(zahiyox[14]),round(zahiyoy[14]));
      lineTo(round(zahiyox[15]),round(zahiyoy[15]));
      moveTo(round(zahiyox[16]),round(zahiyoy[16]));
      lineTo(round(zahiyox[17]),round(zahiyoy[17]));
      lineTo(round(zahiyox[15]),round(zahiyoy[15]));

//p x⏕ qkP
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[12]),round(zahiyoy[12]));
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[19]),round(zahiyoy[19]));

// aAOa
      pen.Color := Clblack;
    end;
  circleb(xdata1, ydata1, Ad1add/2, RLQ2S, RLQ2E);
  circleb(xdata1, ydata1, Ad1sub/2, 0, pi * 2);

// px@
  Form1.Image1.Canvas.pen.Color := Clblue;
  YA(xdata1+(RRLg + RRLg/2 - 5)*cos(setq),ydata1+(RRLg + RRLg/2 - 5)*sin(setq),setq+pi/2);
  YA(xdata1+(RRLg + RRLg/2 - 5)*cos(2*pi-setq),ydata1+(RRLg + RRLg/2 - 5)*sin(2*pi-setq),-setq-pi/2);
  circleb(xdata1, ydata1, RRLg + RRLg/2 - 5, setq, 2 * pi - setq);
  YA(xdata1+(RRLg)*cos(setq),ydata1-(RRLg)*sin(setq), -setq  + pi + pi/2);
  YA(xdata1+(RRLg)*cos(2*pi-(setq+ NGQg)),ydata1+(RRLg)*sin(2*pi-(setq+ NGQg)),-(setq+ NGQg)-pi/2+pi);
  circleb(xdata1, ydata1, RRLg, setq, setq+ NGQg);
  Form1.Image1.Canvas.Brush.Color := clAqua;
// ׏dpx
  Form1.Image1.Canvas.Textout(round(xdata1-tlng-RRLg-RRLg/2),round(ydata1),SLL);
// ˂px
  Form1.Image1.Canvas.font.Height := 14;
  SLL := floatTostrF(NGQg/pi*180,ffGeneral,4,2);
  SLL := SLL + '';
  Slng:= Form1.Image1.Canvas.textwidth(SLL);
  Form1.Image1.Canvas.Textout(round(xdata1-Slng+(RRLg)*cos(2*pi-setq-NGQg/2)),
                      round(ydata1+(RRLg)*sin(2*pi-(setq+ NGQg/2))-13),SLL);

  RL1 := -1;    // r̒@P
  RL2 := -1;    // r̒@Q
  d := -1;      // a
end;

procedure grdisplay;//OtBbN\
var
  qtan,setq,RRL: double;
  RLQ2E,RLQ2S: double;
  qtane: double;
  SLL:string;
  tlng,Slng: integer;
  RL1g,RL2g,Ad1g,dg,RRLg: double;
  Scl: double;
  Ad1add,Ad1sub,NGQg: double;
begin

//     RL1 := 30;//r̒@P
//     RL2 := 40;//r̒@Q
//     Ad1 := 10;//a
//       d := 1;//a
//       ppQ1:= NGQ2//׏dpxWAP
  NGQg:= NGQ2;                  // lWpWAP

  CLEAR(0);
// ׏dpx
  Form1.Image1.Canvas.pen.Style := psSolid;
  Form1.Image1.Canvas.pen.Width := 1;
  Form1.Image1.Canvas.font.Height := 14;
  Form1.Image1.Canvas.font.color := clFuchsia;
  SLL := floatTostrF(ppQ1/pi*180,ffGeneral,5,5);
  SLL := SLL + '';
  tlng:= Form1.Image1.Canvas.textwidth(SLL);

  if RL1 < RL2 then RRL := RL2 else RRL := RL1;
  Scl := (300 - tlng)/(RRL + RRL/2)/2;
  RL1g := RL1 * Scl;            // r̒@P
  RL2g := RL2 * Scl;            // r̒@Q
  Ad1g := Ad * Scl;             // a
  dg := d * Scl;                // a
  RRLg := RRL * Scl;

  Ad1add := Ad1g + dg;
  Ad1sub := Ad1g - dg;

  setq := (2 * pi - ppQ1) / 2;  // r̍}px

  xdata1 := Form1.ClientWidth-(300-tlng)/2;// SWw

  ydata1 := 200;                // SWx
  if RL2g <= Ad1add / 2 then qtan := Pi / 2
                        else qtan := arctan(Ad1add/2/sqrt(RL2g * RL2g - Ad1add/2 * Ad1add/2));//RL2g̊px
  indatx[1] := xdata1 + RL2g;   // qkQ̂wW
  indaty[1] := ydata1;          // qkQ̂xW
  radconv(xdata1, ydata1,indatx[1], indaty[1],-setq);// Wϊ
  zahiyox[1] := zxpos;          // qkQ̉׏dwW
  zahiyoy[1] := zypos;          // qkQ̉׏dxW
  indatx[2] := Ad1add/2 * sin(qtan) + xdata1;// qkQ̊O~wW
  indaty[2] := Ad1add/2 * cos(qtan) + ydata1;// qkQ̊O~xW
  radconv(xdata1, ydata1,indatx[2], indaty[2],-setq);// Wϊ
  zahiyox[2] := zxpos;          // qkQ̉׏dO~wW
  zahiyoy[2] := zypos;          // qkQ̉׏dO~xW
  RLQ2E := zssq;                // qkQ̉׏dO~ړ_p
  RLQ2S := arctan(sqrt(Ad1add/2 * Ad1add/2  - Ad1sub/2 * Ad1sub/2)/(Ad1sub/2));
  RLQ2S := RLQ2S + zssq;        // qkQ̉׏dO~_p
  indatx[3] := indatx[2] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}O~[wW
  indaty[3] := indaty[2] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}O~[xW
  radconv(xdata1, ydata1,indatx[3], indaty[3],-setq);// Wϊ
  zahiyox[3] := zxpos;          // qkQ̍}׏dO~[wW
  zahiyoy[3] := zypos;          // qkQ̍}׏dO~[xW
  indatx[4] := xdata1 + sin(qtan) * Ad1sub/ 2;// qkQ̓~wW
  indaty[4] := ydata1 + cos(qtan) * Ad1sub/ 2;// qkQ̓~xW
  radconv(xdata1, ydata1,indatx[4], indaty[4],-setq);// Wϊ
  zahiyox[4] := zxpos;          // qkQ̉׏d~wW
  zahiyoy[4] := zypos;          // qkQ̉׏d~xW
  indatx[5] := indatx[4] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}~[wW
  indaty[5] := indaty[4] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}~[xW
  radconv(xdata1, ydata1,indatx[5], indaty[5],-setq);// Wϊ
  zahiyox[5] := zxpos;          // qkQ̍}׏d~[wW
  zahiyoy[5] := zypos;          // qkQ̍}׏d~[xW
  indatx[6] := xdata1 + (RRLg + RRLg / 2);// qkQ̕⏕[wW
  indaty[6] := ydata1;          // qkQ̕⏕[xW
  radconv(xdata1, ydata1,indatx[6], indaty[6],-setq);// Wϊ
  zahiyox[6] := zxpos;          // qkQ̉׏d⏕[wW
  zahiyoy[6] := zypos;          // qkQ̉׏d⏕[xW
  if RL1g <= Ad1add / 2 then qtan := pi / 2
                        else qtan := arctan(Ad1add/2/sqrt(RL1g * RL1g - Ad1add/2 * Ad1add/2));//RL1g̊px
  indatx[7] := xdata1 + RL1g;   // qkP̂wW
  indaty[7] := ydata1;          // qkP̂xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq);// Wϊ
  zahiyox[7] := zxpos;          // qkP̉׏dwW
  zahiyoy[7] := zypos;          // qkP̉׏dwW
  indatx[8] := xdata1 + Ad1add/2 * sin(qtan);// qkP̊O~wW
  indaty[8] := ydata1 - Ad1add/2 * cos(qtan);// qkP̊O~wW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq);// Wϊ
  zahiyox[8] := zxpos;          // qkP̉׏dO~wW
  zahiyoy[8] := zypos;          // qkP̉׏dO~xW
  indatx[9] := indatx[8] + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}O~[wW
  indaty[9] := indaty[8] + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}O~[xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq);// Wϊ
  zahiyox[9] := zxpos;          // qkP̍}׏dO~[wW
  zahiyoy[9] := zypos;          // qkP̍}׏dO~[xW
  qtane := arctan(sqrt(Ad1add/2 * Ad1add/2 - Ad1sub/2 * Ad1sub/2)/(Ad1sub /2));// qkP̍}O~_px␳
  indatx[10] := xdata1 + sin(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_wW
  indaty[10] := ydata1 - cos(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq);// Wϊ
  zahiyox[10] := zxpos;         // qkP̍}׏dO~_wW
  zahiyoy[10] := zypos;         // qkP̍}׏dO~_xW
  indatx[11] := xdata1 + sin(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}~[wW
  indaty[11] := ydata1 - cos(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq);// Wϊ
  zahiyox[11] := zxpos;         // qkP̍}׏d~[wW
  zahiyoy[11] := zypos;         // qkP̍}׏d~[xW
  indatx[12] := xdata1 + RRLg + RRLg / 2;//qkP̐@⏕[wW
  indaty[12] := ydata1;         //qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq);// Wϊ
  zahiyox[12] := zxpos;         // qkP̉׏d@⏕[wW
  zahiyoy[12] := zypos;         // qkP̉׏d@⏕[xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq + NGQg);// Wϊ
  zahiyox[13] := zxpos;         // qkP̏pxwW
  zahiyoy[13] := zypos;         // qkP̏pxxW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq + NGQg);// Wϊ
  zahiyox[14] := zxpos;         // qkP̏O~wW
  zahiyoy[14] := zypos;         // qkP̏O~xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq + NGQg);// Wϊ
  zahiyox[15] := zxpos;         // qkP̏O~[wW
  zahiyoy[15] := zypos;         // qkP̏O~[xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq + NGQg);// Wϊ
  zahiyox[16] := zxpos;         // qkP̍}O~_wW
  zahiyoy[16] := zypos;         // qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq + NGQg);// Wϊ
  zahiyox[17] := zxpos;         // qkP̍}~[wW
  zahiyoy[17] := zypos;         // qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq + NGQg);// Wϊ
  zahiyox[18] := zxpos;         // qkP̐@⏕[wW
  zahiyoy[18] := zypos;         // qkP̐@⏕[xW

  indatx[13] := xdata1 + RRLg + 5;// qkP̐@⏕[wW
  indaty[13] := ydata1;           // qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[13], indaty[13], setq + NGQg);// Wϊ
  zahiyox[19] := zxpos;         // qkP̐@⏕[wW
  zahiyoy[19] := zypos;         // qkP̐@⏕[xW

  with Form1.Image1.Canvas do
    begin
      pen.width := 1;
      pen.Color := Clblack;
// RL2g }
      moveTo(round(zahiyox[1]),round(zahiyoy[1]));
      lineTo(round(zahiyox[2]),round(zahiyoy[2]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
      moveTo(round(zahiyox[4]),round(zahiyoy[4]));
      lineTo(round(zahiyox[5]),round(zahiyoy[5]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
// px⏕@qkQ
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[6]),round(zahiyoy[6]));

// RLP }  ׏dpʒu
      pen.Color := Clred;
      moveTo(round(zahiyox[7]),round(zahiyoy[7]));
      lineTo(round(zahiyox[8]),round(zahiyoy[8]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));
      moveTo(round(zahiyox[10]),round(zahiyoy[10]));
      lineTo(round(zahiyox[11]),round(zahiyoy[11]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));

// RLP }  pʒu
      pen.Color := clLime;
      moveTo(round(zahiyox[13]),round(zahiyoy[13]));
      lineTo(round(zahiyox[14]),round(zahiyoy[14]));
      lineTo(round(zahiyox[15]),round(zahiyoy[15]));
      moveTo(round(zahiyox[16]),round(zahiyoy[16]));
      lineTo(round(zahiyox[17]),round(zahiyoy[17]));
      lineTo(round(zahiyox[15]),round(zahiyoy[15]));

// px⏕ qkP
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[12]),round(zahiyoy[12]));
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[19]),round(zahiyoy[19]));

// aAOa
      pen.Color := Clblack;
    end;
  circleb(xdata1, ydata1, Ad1add/2, RLQ2S, RLQ2E);
  circleb(xdata1, ydata1, Ad1sub/2, 0, pi * 2);

// px@
  Form1.Image1.Canvas.pen.Color := Clblue;
  YA(xdata1+(RRLg + RRLg/2 - 5)*cos(setq),ydata1+(RRLg + RRLg/2 - 5)*sin(setq),setq+pi/2);
  YA(xdata1+(RRLg + RRLg/2 - 5)*cos(2*pi-setq),ydata1+(RRLg + RRLg/2 - 5)*sin(2*pi-setq),-setq-pi/2);
  circleb(xdata1, ydata1, RRLg + RRLg/2 - 5, setq, 2 * pi - setq);
  YA(xdata1+(RRLg)*cos(setq),ydata1-(RRLg)*sin(setq), -setq  + pi + pi/2);
  YA(xdata1+(RRLg)*cos(2*pi-(setq+ NGQg)),ydata1+(RRLg)*sin(2*pi-(setq+ NGQg)),-(setq+ NGQg)-pi/2+pi);
  circleb(xdata1, ydata1, RRLg, setq, setq+ NGQg);
// ׏dpx
  Form1.Image1.Canvas.Font.Color := clFuchsia;
  Form1.Image1.Canvas.Textout(round(xdata1-tlng-RRLg-RRLg/2),round(ydata1),SLL);
// ˂px
  Form1.Image1.Canvas.font.Height := 14;
  SLL := floatTostrF(NGQg/pi*180,ffGeneral,4,2);
  SLL := SLL + '';
  Slng:= Form1.Image1.Canvas.textwidth(SLL);
  Form1.Image1.Canvas.Font.Color := clred;
  Form1.Image1.Canvas.Textout(round(xdata1-Slng+(RRLg)*cos(2*pi-setq-NGQg/2)),
                      round(ydata1+(RRLg)*sin(2*pi-(setq+ NGQg/2))-13),SLL);
// Ql}
  with Form1.Image1.Canvas do begin
    Font.color := Clblack;
    pen.width := 2;
    pen.color := clLime;
    moveTo(370,40);
    lineTo(400,40);
    Textout(405,35,'px');
    pen.color := Clred;
    moveTo(500,40);
    lineTo(530,40);
    Textout(535,35,'׏dpx');
  end;
end;

procedure Pgrdisplay;// OtBbN\
var
  qtan,setq,RRL: double;
  RLQ2E,RLQ2S: double;
  qtane: double;
  SLL:string;
  tlng,Slng: integer;
  RL1g,RL2g,Ad1g,dg,RRLg: double;
  Scl: double;
  Ad1add,Ad1sub,NGQg: double;
  keisu: double;
begin

//     RL1 := 30;//r̒@P
//     RL2 := 40;//r̒@Q
//     Ad1 := 10;//a
//       d := 1;//a
//       ppQ1:= NGQ2//׏dpxWAP
  NGQg:= NGQ2;// lWpWAP

//׏dpx
  if printer.PageHeight > printer.PageWidth then keisu := printer.PageWidth / 640
                                            else keisu := printer.PageHeight /640;
  printer.Canvas.pen.Style := psSolid;
  printer.Canvas.pen.Width := 2;
  printer.Canvas.font.size := 12;
  printer.Canvas.font.color := clFuchsia;
  SLL := floatTostrF(ppQ1/pi*180,ffGeneral,5,5);
  SLL := SLL + '';
  tlng:= printer.Canvas.textwidth(SLL);

  if RL1 < RL2 then RRL := RL2 else RRL := RL1;
  Scl := (270 * keisu - tlng)/(RRL + RRL/2)/2;
  RL1g := RL1 * Scl;  // r̒@P
  RL2g := RL2 * Scl;  // r̒@Q
  Ad1g := Ad * Scl;   // a
  dg := d * Scl;      // a
  RRLg := RRL * Scl;

  Ad1add := Ad1g + dg;
  Ad1sub := Ad1g - dg;

  setq := (2 * pi - ppQ1) / 2;  // r̍}px

  xdata1 := ((640 -270 / 2) * keisu-tlng);// SWw

  ydata1 := 400 * keisu;  // SWx
  if RL2g <= Ad1add / 2 then qtan := pi / 2
                        else qtan := arctan(Ad1add/2/sqrt(RL2g * RL2g - Ad1add/2 * Ad1add/2));//RL2g̊px
  indatx[1] := xdata1 + RL2g;// qkQ̂wW
  indaty[1] := ydata1;// qkQ̂xW
  radconv(xdata1, ydata1,indatx[1], indaty[1],-setq);// Wϊ
  zahiyox[1] := zxpos;// qkQ̉׏dwW
  zahiyoy[1] := zypos;// qkQ̉׏dxW
  indatx[2] := Ad1add/2 * sin(qtan) + xdata1;// qkQ̊O~wW
  indaty[2] := Ad1add/2 * cos(qtan) + ydata1;// qkQ̊O~xW
  radconv(xdata1, ydata1,indatx[2], indaty[2],-setq);// Wϊ
  zahiyox[2] := zxpos;// qkQ̉׏dO~wW
  zahiyoy[2] := zypos;// qkQ̉׏dO~xW
  RLQ2E := zssq;// qkQ̉׏dO~ړ_p
  RLQ2S := arctan(sqrt(Ad1add/2 * Ad1add/2  - Ad1sub/2 * Ad1sub/2)/(Ad1sub/2));
  RLQ2S := RLQ2S + zssq;// qkQ̉׏dO~_p
  indatx[3] := indatx[2] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}O~[wW
  indaty[3] := indaty[2] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}O~[xW
  radconv(xdata1, ydata1,indatx[3], indaty[3],-setq);// Wϊ
  zahiyox[3] := zxpos;// qkQ̍}׏dO~[wW
  zahiyoy[3] := zypos;// qkQ̍}׏dO~[xW
  indatx[4] := xdata1 + sin(qtan) * Ad1sub/ 2;// qkQ̓~wW
  indaty[4] := ydata1 + cos(qtan) * Ad1sub/ 2;// qkQ̓~xW
  radconv(xdata1, ydata1,indatx[4], indaty[4],-setq);// Wϊ
  zahiyox[4] := zxpos;// qkQ̉׏d~wW
  zahiyoy[4] := zypos;// qkQ̉׏d~xW
  indatx[5] := indatx[4] + (RL2g + RL2g / 5) * cos(qtan);// qkQ̍}~[wW
  indaty[5] := indaty[4] - (RL2g + RL2g / 5) * sin(qtan);// qkQ̍}~[xW
  radconv(xdata1, ydata1,indatx[5], indaty[5],-setq);// Wϊ
  zahiyox[5] := zxpos;// qkQ̍}׏d~[wW
  zahiyoy[5] := zypos;// qkQ̍}׏d~[xW
  indatx[6] := xdata1 + (RRLg + RRLg / 2);// qkQ̕⏕[wW
  indaty[6] := ydata1;// qkQ̕⏕[xW
  radconv(xdata1, ydata1,indatx[6], indaty[6],-setq);// Wϊ
  zahiyox[6] := zxpos;// qkQ̉׏d⏕[wW
  zahiyoy[6] := zypos;// qkQ̉׏d⏕[xW
  if RL1g <= Ad1add / 2 then qtan := pi / 2
                        else qtan := arctan(Ad1add/2/sqrt(RL1g * RL1g - Ad1add/2 * Ad1add/2));//RL1g̊px
  indatx[7] := xdata1 + RL1g;// qkP̂wW
  indaty[7] := ydata1;// qkP̂xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq);// Wϊ
  zahiyox[7] := zxpos;// qkP̉׏dwW
  zahiyoy[7] := zypos;// qkP̉׏dwW
  indatx[8] := xdata1 + Ad1add/2 * sin(qtan);// qkP̊O~wW
  indaty[8] := ydata1 - Ad1add/2 * cos(qtan);// qkP̊O~wW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq);// Wϊ
  zahiyox[8] := zxpos;//qkP̉׏dO~wW
  zahiyoy[8] := zypos;//qkP̉׏dO~xW
  indatx[9] := indatx[8] + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}O~[wW
  indaty[9] := indaty[8] + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}O~[xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq);// Wϊ
  zahiyox[9] := zxpos;// qkP̍}׏dO~[wW
  zahiyoy[9] := zypos;// qkP̍}׏dO~[xW
  qtane := arctan(sqrt(Ad1add/2 * Ad1add/2 - Ad1sub/2 * Ad1sub/2)/(Ad1sub /2));// qkP̍}O~_px␳
  indatx[10] := xdata1 + sin(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_wW
  indaty[10] := ydata1 - cos(qtan+qtane) * Ad1add/ 2;// qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq);// Wϊ
  zahiyox[10] := zxpos;// qkP̍}׏dO~_wW
  zahiyoy[10] := zypos;// qkP̍}׏dO~_xW
  indatx[11] := xdata1 + sin(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * cos(qtan);// qkP̍}~[wW
  indaty[11] := ydata1 - cos(qtan) * Ad1sub/ 2 + (RL1g + RL1g / 5) * sin(qtan);// qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq);// Wϊ
  zahiyox[11] := zxpos;// qkP̍}׏d~[wW
  zahiyoy[11] := zypos;// qkP̍}׏d~[xW
  indatx[12] := xdata1 + RRLg + RRLg / 2;// qkP̐@⏕[wW
  indaty[12] := ydata1;// qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq);// Wϊ
  zahiyox[12] := zxpos;// qkP̉׏d@⏕[wW
  zahiyoy[12] := zypos;// qkP̉׏d@⏕[xW
  radconv(xdata1, ydata1,indatx[7], indaty[7],setq + NGQg);// Wϊ
  zahiyox[13] := zxpos;// qkP̏pxwW
  zahiyoy[13] := zypos;// qkP̏pxxW
  radconv(xdata1, ydata1,indatx[8], indaty[8], setq + NGQg);// Wϊ
  zahiyox[14] := zxpos;// qkP̏O~wW
  zahiyoy[14] := zypos;// qkP̏O~xW
  radconv(xdata1, ydata1,indatx[9], indaty[9], setq + NGQg);// Wϊ
  zahiyox[15] := zxpos;// qkP̏O~[wW
  zahiyoy[15] := zypos;// qkP̏O~[xW
  radconv(xdata1, ydata1,indatx[10], indaty[10], setq + NGQg);// Wϊ
  zahiyox[16] := zxpos;// qkP̍}O~_wW
  zahiyoy[16] := zypos;// qkP̍}O~_xW
  radconv(xdata1, ydata1,indatx[11], indaty[11], setq + NGQg);// Wϊ
  zahiyox[17] := zxpos;// qkP̍}~[wW
  zahiyoy[17] := zypos;// qkP̍}~[xW
  radconv(xdata1, ydata1,indatx[12], indaty[12], setq + NGQg);// Wϊ
  zahiyox[18] := zxpos;// qkP̐@⏕[wW
  zahiyoy[18] := zypos;// qkP̐@⏕[xW

  indatx[13] := xdata1 + RRLg + 1 * Scl;// qkP̐@⏕[wW
  indaty[13] := ydata1;// qkP̐@⏕[xW
  radconv(xdata1, ydata1,indatx[13], indaty[13], setq + NGQg);// Wϊ
  zahiyox[19] := zxpos;// qkP̐@⏕[wW
  zahiyoy[19] := zypos;// qkP̐@⏕[xW

  with printer.Canvas do
    begin
      pen.width := 1;
      pen.Color := Clblack;
// RL2g }
      moveTo(round(zahiyox[1]),round(zahiyoy[1]));
      lineTo(round(zahiyox[2]),round(zahiyoy[2]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
      moveTo(round(zahiyox[4]),round(zahiyoy[4]));
      lineTo(round(zahiyox[5]),round(zahiyoy[5]));
      lineTo(round(zahiyox[3]),round(zahiyoy[3]));
// px⏕@qkQ
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[6]),round(zahiyoy[6]));

// RLP }  ׏dpʒu
      pen.Style := psdash;
      pen.Color := Clred;
      moveTo(round(zahiyox[7]),round(zahiyoy[7]));
      lineTo(round(zahiyox[8]),round(zahiyoy[8]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));
      moveTo(round(zahiyox[10]),round(zahiyoy[10]));
      lineTo(round(zahiyox[11]),round(zahiyoy[11]));
      lineTo(round(zahiyox[9]),round(zahiyoy[9]));

// RLP }  pʒu
      pen.Style := psSolid;
      pen.Color := clLime;
      moveTo(round(zahiyox[13]),round(zahiyoy[13]));
      lineTo(round(zahiyox[14]),round(zahiyoy[14]));
      lineTo(round(zahiyox[15]),round(zahiyoy[15]));
      moveTo(round(zahiyox[16]),round(zahiyoy[16]));
      lineTo(round(zahiyox[17]),round(zahiyoy[17]));
      lineTo(round(zahiyox[15]),round(zahiyoy[15]));

// px⏕ qkP
      pen.Color := Clblue;
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[12]),round(zahiyoy[12]));
      moveTo(round(xdata1),round(ydata1));
      lineTo(round(zahiyox[19]),round(zahiyoy[19]));

// aAOa
      pen.Color := Clblack;
  end;
  Pcircleb(xdata1, ydata1, Ad1add/2, RLQ2S, RLQ2E);
  Pcircleb(xdata1, ydata1, Ad1sub/2, 0, pi * 2);

// px@
  printer.Canvas.pen.Color := Clblue;
  PYA(xdata1+(RRLg + RRLg/2 - 5)*cos(setq),ydata1+(RRLg + RRLg/2 - 5)*sin(setq),setq+pi/2,keisu);
  PYA(xdata1+(RRLg + RRLg/2 - 5)*cos(2*pi-setq),ydata1+(RRLg + RRLg/2 - 5)*sin(2*pi-setq),-setq-pi/2,keisu);
  Pcircleb(xdata1, ydata1, RRLg + RRLg/2 - 5, setq, 2 * pi - setq);
  PYA(xdata1+(RRLg)*cos(setq),ydata1-(RRLg)*sin(setq), -setq  + pi + pi/2,keisu);
  PYA(xdata1+(RRLg)*cos(2*pi-(setq+ NGQg)),ydata1+(RRLg)*sin(2*pi-(setq+ NGQg)),-(setq+ NGQg)-pi/2+pi,keisu);
  Pcircleb(xdata1, ydata1, RRLg, setq, setq+ NGQg);
// ׏dpx
  printer.Canvas.Textout(round(xdata1-tlng-RRLg-RRLg/2),round(ydata1),SLL);
// ˂px
  SLL := floatTostrF(NGQg/pi*180,ffGeneral,4,2);
  SLL := SLL + '';
  Slng:= printer.Canvas.textwidth(SLL);
  with printer.Canvas do
    begin
      Textout(round(xdata1-Slng+(RRLg)*cos(2*pi-setq-NGQg/2)),
                                      round(ydata1+(RRLg)*sin(2*pi-(setq+ NGQg/2))-13),SLL);
// Ql}
      Font.color := Clblack;
      pen.width := 2;
      pen.color := clLime;
      moveTo(round(370*keisu),round(240*keisu));
      lineTo(round(400*keisu),round(240*keisu));
      Textout(round(405*keisu),round(235*keisu),'px');
      pen.Style := psdash;
      pen.color := Clred;
      moveTo(round(500*keisu),round(240*keisu));
      lineTo(round(530*keisu),round(240*keisu));
      Textout(round(535*keisu),round(235*keisu),'׏dpx');
      pen.Style := psSolid;
    end;
end;

procedure startdemo;{X^[g̉ʕ\}
begin
  with Form1 do begin
    BorderStyle := BsNone;
    clear(1);
    top := (Screen.Height - Form1.Height) div 2;
    left:= (Screen.Width - Form1.Width) div 2;
    with Image1.Canvas do begin
      pen.width := 1;
      pen.color := Clwhite;
      moveTo(15,15);
      LineTo(15,385);
      LineTo(385,385);
      LineTo(385,15);
      LineTo(15,15);
      MoveTo(0,0);
      LineTo(15,15);
      MoveTo(0,400);
      LineTo(15,385);
      MoveTo(400,400);
      lineTo(385,385);
      MoveTo(400,0);
      LineTo(385,15);
      Brush.Color := clLtGray;
      Brush.style := bsSolid;
      FloodFill(200,7,clAqua,fsSurface);
      Brush.Color := clLtGray;
      FloodFill(7,200,clAqua,fsSurface);
      Brush.Color := clGray;
      FloodFill(397,200,clAqua,fsSurface);
      Brush.Color := clDkGray;
      FloodFill(200,397,clAqua,fsSurface);
    end;
  end;
  Demogrdisplay;// OtBbN\
  color(0);
  OutGDBCS(100,80,'Ver.2006',30);
  color(12);
  OutGDBCS(22,160,'˂RColvZ',30);
  color(1);
  OutGDBCS(22,300,'@{vO͎gp҂̐ӔCɉĎgpĉB',10);
  OutGDBCS(22,312,'̃vO̎gpɂɂẮAӔC',10);
  OutGDBCS(22,324,'vO̒񋟎҂ɂ͂܂B',10);
  color(0);
  OutGDBCS(100,365,'lD',15);
end;

procedure pic;{lWRCol}}
var
  XX0, YY0:   Double;
begin
  clear(0);
  XX0 := 510;
  YY0 := 210;
  Form1.Image1.Canvas.Pen.Style := psSolid;
  Form1.Image1.Canvas.pen.Width := 1;
  CIRCLE(XX0 - 4, YY0, 22, 12, 0, pi + pi);
  PAINT(XX0 - 4, YY0, 13, 12);
  CIRCLE(XX0, YY0, 26, 2, 0, Pi + pi);
  CIRCLE(XX0, YY0, 36, 2, pi / 2 * 3 + 0.2, pi / 2 * 2 + 1.02);
  CIRCLE(XX0 + 20, YY0 - 100, 8, 3, 0, pi + pi);
  PAINT(XX0 + 20, YY0 - 100, 3, 3);
  CIRCLE(XX0 + 30, YY0 + 70, 8, 3, 0, pi + pi);
  PAINT(XX0 + 30, YY0 + 70, 3, 3);
  CIRCLE(XX0 - 26.38, YY0 - 98.52, 8, 3, 0, pi + pi);
  PAINT(XX0 - 26.38, YY0 - 98.52, 3, 3);
  CIRCLE(XX0 - SIN(pi / 12) * 180, YY0 - COS(pi / 12) * 180, 4, 4, 0, pi + pi);
  LINE(XX0 + 37.262, YY0 - 186.3104, XX0, YY0, 5);
  LINE(XX0 - 49.14, YY0 - 183.52, XX0, YY0, 5);
  LINE(XX0, YY0, XX0 + 59.0878, YY0 + 137.8718, 5);
  CIRCLE(XX0 + 20, YY0 - 100, 18, 2, pi / 2 * 3 + 0.927, pi / 2);
  LINE(XX0 + 20, YY0 - 118, XX0 + 20, YY0 - 108, 2);
  CIRCLE(XX0 + 30, YY0 + 70, 18, 2, pi / 2 * 3, 1.02);
  CIRCLE(XX0, YY0, Sqrt(10 * 10 + 50 * 50) * 2, 2, 1.373, 1.832);
  CIRCLE(XX0, YY0, 180, 3, ArcTan(50 / 10), pi - ArcTan(91.76 / 24.57));
  LINE(XX0 + 30, YY0 + 88, XX0 + 30, YY0 + 78, 2);
  LINE(XX0 - 28.8, YY0 - 21.6, XX0 + 26.4, YY0 - 95.2, 2);
  YA(XX0 + 35.3, YY0 - 176.5, 3.36);
  LINE(XX0 - 5.84, YY0 - 35.52, XX0 + 34.4, YY0 - 89.2, 2);
  LINE(XX0 - 13.58, YY0 + 22.2, XX0 + 38.94, YY0 + 55.34, 2);
  LINE(XX0 - 18.84, YY0 + 30.68, XX0 + 36.82, YY0 + 65.82, 2);
  CIRCLE(XX0, YY0, 140, 3, 1.3734, 5.117);
  YA(XX0 + 55.14, YY0 + 128.68, 2.85);
  YA(XX0 + 27.44, YY0 - 137.28, 3.36);
  LINE(XX0 + 20, YY0 - 100, XX0 - 40, YY0 - 112, 5);
  LINE(XX0, YY0, XX0 - 60, YY0 - 12, 5);
  LINE(XX0, YY0, XX0 - 60, YY0 + 25.7, 5);
  LINE(XX0 + 30, YY0 + 70, XX0 - 30, YY0 + 95.7, 5);
  LINE(XX0 - 36, YY0 - 111.2, XX0 - 57, YY0 - 11.2, 3);
  LINE(XX0 - 56, YY0 + 24, XX0 - 26, YY0 + 94, 3);
  YA(XX0 - 36, YY0 -111.2, 1.8);
  YA(XX0 - 57, YY0 - 11.2, 4.94);
  YA(XX0 - 56, YY0 + 24, 1.2);
  YA(XX0 - 26, YY0 + 94, 4.34);
  LINE(XX0 + 14, YY0 - 14, XX0 + 40, YY0 - 66, 3);
  LINE(XX0 + 40, YY0 - 66, XX0 + 104, YY0 - 66, 3);
  YA(XX0 + 14, YY0 - 14, 5.2);
  color(0);
  Form1.Image1.Canvas.Brush.Color := clGray;
  Form1.Image1.Canvas.Brush.Style := bsSolid;
  fillsikaku(XX0 -62,YY0 -  70,XX0 -30,YY0 -  55);
  fillsikaku(XX0 - 52,YY0 + 52,XX0 - 20,YY0 +  67);
  OutGDBCS(XX0 - 62, YY0 - 70, 'qP', 12);
  OutGDBCS(XX0 - 52, YY0 + 52, 'qQ', 12);
  Form1.Image1.Canvas.Brush.Color := clAqua;
  fillsikaku(XX0 + 40,YY0 - 82 ,XX0 + 104,YY0 - 67);
  OutGDBCS(XX0 + 40, YY0 - 82, 'ē_a', 12);
  Form1.Image1.Canvas.Brush.Color := clYellow;
  fillsikaku(XX0 -150,YY0 -  6,XX0 -75,YY0 +  9);
  fillsikaku(XX0 -148,YY0 +  10,XX0 -116,YY0 +  25);
  OutGDBCS(XX0 -150, YY0 -  6, '׏dpx',12);
  OutGDBCS(XX0 -148, YY0 + 10, 'pP', 12);
  Form1.Image1.Canvas.Brush.Color := clLime;
  fillsikaku(XX0 - 40,YY0 - 196,XX0 + 28,YY0 - 181);
  fillsikaku(XX0 - 32,YY0 - 176,XX0 + 2,YY0 - 161);
  OutGDBCS(XX0 - 40, YY0 -196, 'lWp', 12);
  OutGDBCS(XX0 - 32, YY0 -176, 'pQ', 12);
  color(12);
  Form1.Image1.Canvas.Brush.Color := clWhite;
  Form1.Image1.Canvas.Font.height := 15;
  Form1.Image1.Canvas.Textout(round(XX0 -132), round(YY0 +134), 'gN̒Pʂɒ ');
  Form1.Image1.Canvas.Textout(round(XX0 -102), round(YY0 +150), 'mE@łB');
end;

procedure coilo(xpos,ypos: Double);{RC}}
var
  fleng,wird,dai,farstpx,farstpy: Double;
  lp,pich,qsp,farstpx1,xdel,ydel,farstpy1: Double;
  dire, I:   integer;
begin
  fleng := 50;  {}
  wird := 10;   {a}
  dai := 25;    {a}
  dire := 4;    {}
  farstpx := 310 + xpos;
  farstpy := 68 + ypos;
  lp := fleng - wird;{L}
  pich := lp / dire / 2;{sb`}
  qsp := ArcTan(pich / (dai + wird));{px}
  farstpx1 := farstpx + wird / 2;
  xdel := COS(qsp) * wird / 2;
  ydel := SIN(qsp) * wird / 2;
  farstpy1 := farstpy + dai + wird;
  Form1.Image1.Canvas.Pen.Style := psSolid;
  Form1.Image1.Canvas.pen.Width := 2;
  LINE (farstpx1 - xdel, farstpy + ydel, farstpx1 + pich - xdel, farstpy1 + ydel, 2);
  I := dire;
  LINE(farstpx1 + I * pich * 2 + xdel, farstpy - ydel,
  farstpx1 + pich + (I + 1) * pich * 2 + xdel, farstpy1 - ydel + dai * 2, 10);
  LINE(farstpx1 + I * pich * 2 - xdel, farstpy + ydel, farstpx1 + pich + (I + 1) * pich * 2 - xdel,
                                                              farstpy1 + ydel + dai * 2, 10);
  LINE(farstpx1 + pich + (I + 1) * pich * 2 - xdel, farstpy1 + ydel + dai * 2,
                    farstpx1 + pich + (I + 1) * pich * 2 + xdel, farstpy1 -ydel + dai * 2, 10);
  Form1.Image1.Canvas.pen.Width := 2;
  CIRCLE(farstpx1, farstpy, wird / 2, 2, 0, pi +pi);
  for I := 1 to dire do CIRCLE(farstpx1 + I * pich * 2, farstpy,wird / 2, 2, 2 * pi - qsp, pi - qsp);
  for I := 0 to dire - 1 do CIRCLE (farstpx1 + pich + I * pich * 2, farstpy1, wird / 2, 2, pi - qsp, 2 * pi - qsp);
  for I := 1 to dire do
    begin
      LINE(farstpx1 - pich + I * pich * 2 - xdel, farstpy1 - ydel, farstpx1 + I * pich * 2 - xdel, farstpy - ydel, 2);
      LINE(farstpx1 - pich + I * pich * 2 + xdel, farstpy1 + ydel, farstpx1 + I * pich * 2 + xdel, farstpy + ydel, 2);
    end;
  PAINT (farstpx1, farstpy, 9, 2);
  for I := 0 to dire - 1 do PAINT (farstpx1 + pich + I * pich * 2, farstpy1, 9, 2);
  Form1.Image1.Canvas.pen.Width := 1;
  Form1.Image1.Canvas.Pen.Style := psDot;
  LINE(farstpx - 10, farstpy, farstpx + fleng + 10, farstpy, 6);
  LINE(farstpx - 10, farstpy + dai + wird, farstpx + fleng + 10, farstpy + dai + wird, 6);
  Form1.Image1.Canvas.Pen.Style := psSolid;
  LINE(farstpx, farstpy - 5, farstpx, farstpy - 50, 0);
  LINE(farstpx + pich * 2 * (dire + 1), farstpy - 5, farstpx + pich * 2 * (dire + 1), farstpy - 50, 0);
  LINE(farstpx - 20, farstpy - 45, farstpx + pich * 2 * (dire + 1) + 20, farstpy - 45, 0);
  YA(farstpx, farstpy - 45, pi);
  YA(farstpx + pich * 2 * (dire + 1), farstpy - 45, 0);
  Form1.Image1.Canvas.Pen.Style := psDot;
  LINE(farstpx - 3, farstpy + (dai + wird) / 2, farstpx + fleng + 10, farstpy + (dai + wird) / 2, 6);
  LINE(farstpx1, farstpy - wird, farstpx1, farstpy + wird, 6);
  Form1.Image1.Canvas.Brush.Color := clFuchsia;
  fillsikaku(farstpx - 32, farstpy - 67,farstpx + 80,farstpy - 51);
  color(0);
  OutGDBCS(farstpx - 30, farstpy - 66, 'ol̋e', 12);
  color(9);
  OutGDBCS(10, 50, 'qP@qQ̓ol̊a̔a', 12);
  OutGDBCS(10, 66, 'ZƎIɔaɕ␳܂B', 12);
end;

procedure picc;{lWRCol}}
var
  XX0, YY0:   Double;
begin
  clear(0);
  XX0 := 510;
  YY0 := 210;
  Form1.Image1.Canvas.Pen.Style := psSolid;
  Form1.Image1.Canvas.pen.Width := 1;
  CIRCLE(XX0, YY0, 26, 2, 0, Pi + pi);
  CIRCLE(XX0, YY0, 36, 2, pi / 2 * 3 + 0.2, pi / 2 * 2 + 1.02);
  CIRCLE(XX0 + 20, YY0 - 100, 8, 3, 0, pi + pi);
  PAINT(XX0 + 20, YY0 - 100, 3, 3);
  CIRCLE(XX0 + 30, YY0 + 70, 8, 3, 0, pi + pi);
  PAINT(XX0 + 30, YY0 + 70, 3, 3);
  CIRCLE(XX0 - 26.38, YY0 - 98.52, 8, 3, 0, pi + pi);
  PAINT(XX0 - 26.38, YY0 - 98.52, 3, 3);
  CIRCLE(XX0 - COS(1.975) * 180, YY0 + SIN(1.975) * 180, 6, 4, 0, pi + pi);
  PAINT(XX0 - COS(1.975) * 180, YY0 + SIN(1.975) * 180, 12, 4);
  LINE(XX0 + 37.262, YY0 - 186.3104, XX0, YY0, 5);
  LINE(XX0 - 39.32, YY0 - 146.82, XX0, YY0, 5);
  LINE(XX0, YY0, XX0 + 73.86, YY0 + 172.34, 5);
  CIRCLE(XX0 + 20, YY0 - 100, 18, 2, pi / 2 * 3 + 0.927, pi / 2);
  LINE(XX0 + 20, YY0 - 118, XX0 + 20, YY0 - 108, 2);
  CIRCLE(XX0 + 30, YY0 + 70, 18, 2, pi / 2 * 3, 1.02);
  CIRCLE(XX0, YY0, Sqrt(10 * 10 + 50 * 50) * 2, 2, 1.373, 1.832);
  CIRCLE(XX0, YY0, 180, 3, ArcTan(50 / 10), 5.117);{׏dpx}
  LINE(XX0 + 30, YY0 + 88, XX0 + 30, YY0 + 78, 2);
  LINE(XX0 - 28.8, YY0 - 21.6, XX0 + 26.4, YY0 - 95.2, 2);
  YA(XX0 + 35.3, YY0 - 176.5, 3.36);
  LINE(XX0 - 5.84, YY0 - 35.52, XX0 + 34.4, YY0 - 89.2, 2);
  LINE(XX0 - 13.58, YY0 + 22.2, XX0 + 38.94, YY0 + 55.34, 2);
  LINE(XX0 - 18.84, YY0 + 30.68, XX0 + 36.82, YY0 + 65.82, 2);
  CIRCLE(XX0, YY0, 140, 3, pi-Arctan(91.76/24.57), 5.117);
  YA(XX0 + 55.14, YY0 + 128.68, 2.85);
  YA(XX0 - 36.2, YY0 - 135.2, 3);
  LINE(XX0 + 20, YY0 - 100, XX0 - 40, YY0 - 112, 5);
  LINE(XX0, YY0, XX0 - 60, YY0 - 12, 5);
  LINE(XX0, YY0, XX0 - 60, YY0 + 25.7, 5);
  LINE(XX0 + 30, YY0 + 70, XX0 - 30, YY0 + 95.7, 5);
  LINE(XX0 - 36, YY0 - 111.2, XX0 - 57, YY0 - 11.2, 3);
  LINE(XX0 - 56, YY0 + 24, XX0 - 26, YY0 + 94, 3);
  YA(XX0 - 36, YY0 -111.2, 1.8);
  YA(XX0 - 57, YY0 - 11.2, 4.94);
  YA(XX0 - 56, YY0 + 24, 1.2);
  YA(XX0 - 26, YY0 + 94, 4.34);
  LINE(XX0 + SIN(pi/4) * 26, YY0 - COS(pi/4) * 26, XX0 + 44, YY0 - 66, 3);
  LINE(XX0 + 44, YY0 - 66, XX0 + 100, YY0 - 66, 3);
  YA(XX0 + SIN(pi/4) * 26, YY0 - COS(pi/4) * 26, 5.2);
  color(0);
  Form1.Image1.Canvas.Brush.Color := clGray;
  fillsikaku(XX0 -62,YY0 -  70,XX0 -30,YY0 -  55);
  fillsikaku(XX0 - 52,YY0 + 52,XX0 - 20,YY0 +  67);
  OutGDBCS(XX0 - 62, YY0 - 70, 'qP', 12);
  OutGDBCS(XX0 - 52, YY0 + 52, 'qQ', 12);
  Form1.Image1.Canvas.Brush.Color := clAqua;
  fillsikaku(XX0 + 49,YY0 - 82 ,XX0 + 90,YY0 - 67);
  OutGDBCS(XX0 + 50, YY0 - 82, ' a', 12);
  Form1.Image1.Canvas.Brush.Color := clYellow;
  fillsikaku(XX0 -150,YY0 -  6,XX0 -90,YY0 +  9);
  fillsikaku(XX0 -148,YY0 +  10,XX0 -116,YY0 +  25);
  OutGDBCS(XX0 -150, YY0 -  6, 'px',12);
  OutGDBCS(XX0 -148, YY0 + 10, 'pP', 12);
  Form1.Image1.Canvas.Brush.Color := clLime;
  fillsikaku(XX0 - 40,YY0 - 196,XX0 + 35,YY0 - 181);
  fillsikaku(XX0 - 32,YY0 - 176,XX0 + 2,YY0 - 161);
  OutGDBCS(XX0 - 40, YY0 -196, '׏dpx', 12);
  OutGDBCS(XX0 - 32, YY0 -176, 'pQ', 12);
  Line(XX0 + 10, YY0, XX0 + 100, YY0, 0);
  YA(XX0 + 26,YY0,pi);
  YA(XX0 + 36,YY0,0);
  Form1.Image1.Canvas.Brush.Color := clFuchsia;
  fillsikaku(XX0 + 48,YY0 - 17,XX0 + 100 ,YY0 - 1);
  OutGDBCS(XX0 + 50, YY0 - 16,'@a',12);
  color(12);
  OutGDBCS(XX0 -132, YY0 +134, 'gN̒Pʂɒ', 12);
  OutGDBCS(XX0 -102, YY0 +150, 'mE@łB', 12);
  color(10);
  OutGDBCS(16, 16, 'lWRCol`FbNvZ', 16);
  color(9);
  OutGDBCS(10, 50, 'qP@qQ̓ol̊a̔a', 12);
  OutGDBCS(10, 66, 'ZƎIɔaɕ␳܂B', 12);
end;

end.
